const { getDefaultConfig, mergeConfig } = require('@react-native/metro-config');

const {
  withSentryConfig
} = require("@sentry/react-native/metro");

const defaultConfig = getDefaultConfig(__dirname);

const { assetExts, sourceExts } = defaultConfig.resolver;

const config = {
  resolver: {
    assetExts: [...assetExts.filter((ext) => ext !== "svg"), "lottie"],
    sourceExts: [...sourceExts, "svg"],
    extraNodeModules: require("node-libs-react-native")
  },
  transformer: {
    babelTransformerPath: require.resolve(
      "react-native-svg-transformer/react-native"
    ),
    getTransformOptions: async () => ({
      transform: {
        experimentalImportSupport: false,
        inlineRequires: true
      }
    })
  }
};

module.exports = withSentryConfig(mergeConfig(defaultConfig, config));